# -*- coding: utf-8 -*-
"""sma_7_eda_visualization_prac_exam.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1-S42916j1AqNNgHjcduzAD-2j4SjUIzc
"""

import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns

# Load the dataset from CSV
data = pd.read_csv('dataset.csv')

# Display the first few rows of the dataset
print("First few rows of the dataset:")
print(data.head())

# Summary statistics
print("\nSummary statistics:")
print(data.describe())

# Data types of columns
print("\nData types of columns:")
print(data.dtypes)

# Check for missing values
print("\nMissing values:")
print(data.isnull().sum())

# Correlation matrix
correlation_matrix = data.corr()
print("\nCorrelation matrix:")
print(correlation_matrix)

# Heatmap of correlation matrix
plt.figure(figsize=(10, 8))
sns.heatmap(correlation_matrix, annot=True, cmap='viridis', fmt=".2f")
plt.title('Correlation Matrix')
plt.show()

# Histogram of numeric columns
numeric_cols = data.select_dtypes(include=['int64', 'float64']).columns
plt.figure(figsize=(10, 6))
for col in numeric_cols:
    sns.histplot(data[col], bins=20, kde=True, label=col)
plt.xlabel('Value')
plt.ylabel('Frequency')
plt.title('Histogram of Numeric Columns')
plt.legend()
plt.show()

# Count plot of categorical columns
categorical_cols = data.select_dtypes(include=['object']).columns
plt.figure(figsize=(10, 6))
for col in categorical_cols:
    sns.countplot(x=col, data=data, palette='viridis')
    plt.xlabel(col)
    plt.ylabel('Count')
    plt.title(f'Count Plot of {col}')
    plt.show()

# plot more like wordlcloud, barplot, scatterplot
# dallu jrnl page 34